/// @file

#ifndef GEM_SUPERVISOR_EXCEPTION_EXCEPTION_H
#define GEM_SUPERVISOR_EXCEPTION_EXCEPTION_H

#include <gem/utils/exception/Exception.h>

#define GEM_SUPERVISOR_DEFINE_EXCEPTION(EXCEPTION_NAME) GEM_DEFINE_EXCEPTION(EXCEPTION_NAME, supervisor)
GEM_SUPERVISOR_DEFINE_EXCEPTION(Exception)
GEM_SUPERVISOR_DEFINE_EXCEPTION(ConfigurationParseProblem)
GEM_SUPERVISOR_DEFINE_EXCEPTION(ConfigurationProblem)
GEM_SUPERVISOR_DEFINE_EXCEPTION(ConfigurationValidationProblem)
GEM_SUPERVISOR_DEFINE_EXCEPTION(MonitoringProblem)
GEM_SUPERVISOR_DEFINE_EXCEPTION(MonitoringValidationProblem)

GEM_SUPERVISOR_DEFINE_EXCEPTION(HardwareProblem)
GEM_SUPERVISOR_DEFINE_EXCEPTION(CommunicationProblem)

GEM_SUPERVISOR_DEFINE_EXCEPTION(RCMSNotificationError)
GEM_SUPERVISOR_DEFINE_EXCEPTION(SOAPTransitionProblem)

GEM_SUPERVISOR_DEFINE_EXCEPTION(SoftwareProblem)
GEM_SUPERVISOR_DEFINE_EXCEPTION(TransitionProblem)
GEM_SUPERVISOR_DEFINE_EXCEPTION(ValueError)

#define GEM_SUPERVISOR_DEFINE_ALARM(ALARM_NAME) GEM_SUPERVISOR_DEFINE_EXCEPTION(ALARM_NAME)
GEM_SUPERVISOR_DEFINE_ALARM(MonitoringFailureAlarm)

#endif // GEM_SUPERVISOR_EXCEPTION_EXCEPTION_H
